$AdaSha::TickRate = 1000;
$AdaSha::ChangeRate = 60;
$AdaSha::MinFPS = 50;
$AdaSha::MaxFPS = 70;
function AdaShaTick()
{
	if($Pref::AdaSha)
	{
		if(isObject(ServerConnection) && isObject(ServerConnection.getControlObject()))
		{
			cancel($AdaSha::Schedule);
			%transform = ServerConnection.getControlObject().getTransform();
			if(%transform !$= $AdaSha::LastTransform)
			{
				$AdaSha::FPSReal[$AdaSha::Tick++] = $FPS::Real;
				if($AdaSha::Tick > $AdaSha::ChangeRate)
				{
					$AdaSha::LastTransform = %transform;
					$AdaSha::Tick = 0;
					for(%a=1;%a<=$AdaSha::ChangeRate;%a++)
						%totalfps += $AdaSha::FPSReal[%a];
					%avgfps = %totalfps/$AdaSha::ChangeRate;
					if(%avgfps < $AdaSha::MinFPS)
					{
						if($Pref::ShaderQuality > 0)
							optionsDlg.setShaderQuality($Pref::ShaderQuality--);
					}
					else if(%avgfps > $AdaSha::MaxFPS)
					{
						if($Pref::ShaderQuality < 6)
							optionsDlg.setShaderQuality($Pref::ShaderQuality++);
					}
				}
			}
			$AdaSha::Schedule = schedule($AdaSha::TickRate,0,"AdaShaTick");
		}
		else
			$AdaSha::Schedule = schedule($AdaSha::TickRate*$AdaSha::ChangeRate,0,AdaShaTick);
	}
}
function AdaShaToggle()
{
	$AdaSha::Tick = 0;
	if($Pref::AdaSha)
	{
		AdaShaTick();
		OptGraphicsPane.getObject(2).color = "99 99 99 200";
	}
	else
		OptGraphicsPane.getObject(2).color = "255 255 255 200";
}
new GuiCheckBoxCtrl(AdaShaCheckBox)
{
	profile = "OptionsMenuTextProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "140 3";
	extent = "40 18";
	minExtent = "8 2";
	value = $Pref::AdaSha;
	enabled = "1";
	visible = "1";
	clipToParent = "1";
	variable = "$Pref::AdaSha";
	command = "AdaShaToggle();";
	text = "Auto";
	groupNum = "-1";
	buttonType = "ToggleButton";
};
OptGraphicsPane.getObject(2).add(AdaShaCheckBox);
if($Pref::AdaSha)
{
	schedule($AdaSha::TickRate*$AdaSha::ChangeRate,0,AdaShaTick);
	OptGraphicsPane.getObject(2).color = "99 99 99 200";
}
			